// --------------------------------------------------------------------------
//
// Copyright (c) 2003 Thomas D. Marsh. All rights reserved.
//
// "SSC" is free software; you can redistribute it
// and/or use it and/or modify it under the terms of
// the "GNU General Public License" (GPL).
//
// --------------------------------------------------------------------------

#ifndef SSC_SHIP_H
#define SSC_SHIP_H

#include "shield.h"
#include "explode.h"


class Ship : public ScreenObject
{
public:
	Ship(double x, double y);
	~Ship();

	void draw();
	void fire();
	void move(double dt);
	void accelerate(double amt);
	void init();

	bool collision(ScreenObject &obj);

	void rotate(double amt);

	double rx, ry;
	void damage(double amt);
	Shield shield;
	Explosion<100> explosion;
	double mLife;
};

#endif // SSC_SHIP_H
